<template>
  <div
    :class="['balloon', 'balloon-popup', '__box-white', balloonDirection]"
    :style="getBalloonStyle()">
    <div class="sellerBasic">
      <div class="sellerBasic-item">
        <AppRating
          :current-rating="entity.avgRating || 0"
          :size="11"/>
        <span class="sellerBasic-reviews">
          <template v-if="entity.feedbackCount">
            {{ entity.feedbackCount }}
            {{ entity.feedbackCount | transChoose(['отзыв', 'отзыва', 'отзывов']) }}
          </template>
        </span>
      </div>
      <div class="sellerBasic-item __hide-shadow">
        <flink
          class="link"
          :href="`/seller/${entity.sellerURL}`"
          target="_blank">
          <span class=" __no-wrap">
            {{ entity.shopName }}
            <img
              v-if="entity.contactIsConfirmed"
              svg-inline
              :class="{absolute: isIconAbsolute(entity.shopName.length)}"
              src="~/assets/svg/redesign/ok-small-blue.svg">
          </span>
        </flink>
      </div>

      <div
        v-if="entity.scheduleDayIsSet"
        class="sellerBasic-item scheduleStatus">
        <ScheduleOpenedNow :part="entity.schedule"/>
      </div>

      <div class="sellerBasic-address __hide-shadow">
        <span class="__medium">{{ entity.cityName }}</span>,
        {{ getAddressByPart(entity) }}
      </div>

      <div class="sellerAvailability __hide-shadow">
        <AppSellerPrice
          :discount="entity.discountCheck"
          :price="entity.price"
          :old-price="entity.oldPrice"/>
        <AppSellerQuantity
          v-if="entity.sellerQuantity"
          :in-stock="entity.inStock"
          :quantity="entity.quantity"
          :under-order="entity.deliveryString"/>
      </div>

      <AppButton
        v-if="withFastOrder"
        :classes="['buttonOrder']"
        @click.native="$emit('click-fast-order')">
        <template #button-item>Быстрый заказ</template>
      </AppButton>

      <button
        class="balloon-popup-close-button"
        @click="$emit('close-balloon', entity.id)">
        <img
          svg-inline
          src="~/assets/svg/icons/i-close.svg">
      </button>
    </div>
  </div>
</template>

<script>
import AppSellerPrice from '~/components/redesign/seller/app-seller-price';
import AppSellerQuantity from '~/components/redesign/seller/app-seller-quantity';
import AppRating from '~/components/redesign/app-rating';
import ScheduleOpenedNow from '~/components/blocks/schedule-opened-now';
import AppButton from '~/components/redesign/app-buttons/app-button';
import createBalloonEntity from '~/assets/js/helpers/balloon/createBalloonEntity';

export default {
  name: 'AppMapPopupBalloon',
  components: {
    AppSellerQuantity,
    AppSellerPrice,
    ScheduleOpenedNow,
    AppButton,
    AppRating,
  },
  props: {
    balloonEntity: {
      type: Object,
      default() { return {}; },
    },
    balloonPosition: {
      type: Array,
      default() { return [0, 0]; },
    },
    balloonDirection: {
      type: String,
      default: 'default',
    },
    balloonConfiguration: {
      type: Object,
      default() { return {}; },
    },
    balloonOpened: {
      type: Boolean,
      default: false,
    },
    withFastOrder: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      width: 0,
      height: 0,
    };
  },
  computed: {
    position() {
      switch (this.balloonDirection) {
        case 'left':
          return ({
            marginLeft: `-${this.width - 50}px`,
            marginTop: `-${this.height + 15}px`,
          });

        case 'top':
          return ({
            marginLeft: `-${this.width / 2}px`,
            marginTop: '45px',
          });

        case 'left top':
          return ({
            marginLeft: `-${this.width - 50}px`,
            marginTop: '45px',
          });

        default:
          return ({
            marginLeft: `-${this.width / 2 - 10}px`,
            marginTop: `-${this.height + 15}px`,
          });
      }
    },
    entity() {
      return createBalloonEntity(this.balloonConfiguration.type, this.balloonEntity);
    },
  },
  updated() {
    if (this.balloonOpened) {
      this.getSize();
    }
  },
  methods: {
    getAddressByPart(part) {
      const result = [];

      if (part.isNetShop) {
        result.push('интернет магазин');
      } else {
        if (part.street) {
          result.push(part.street);
        }
        if (part.building) {
          result.push(part.building);
        }
        if (part.office) {
          result.push(`офис ${part.office}`);
        }
      }
      return result.join(', ');
    },
    getBalloonStyle() {
      return ({
        left: `${this.balloonPosition[0]}px`,
        top: `${this.balloonPosition[1]}px`,
        ...this.position,
      });
    },
    getSize() {
      const { offsetWidth, offsetHeight } = document.querySelector('.balloon-popup');

      this.width = offsetWidth;
      this.height = offsetHeight;
    },
    isIconAbsolute(length) {
      return length > 28;
    },
  },
};
</script>
